unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, AppEvnts, StdCtrls, ComCtrls, ExtCtrls, Menus;

type
  PRec = ^TRec;
  TRec = record
    Wnd:THandle;
    Cls:String;
    Txt:String;
  end;
  TForm1 = class(TForm)
    TreeView1: TTreeView;
    Panel1: TPanel;
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    PopupMenu1: TPopupMenu;
    E1: TMenuItem;
    V1: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N1: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure TreeView1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure E1Click(Sender: TObject);
  private
    { Private declarations }
  public
    procedure FreeRec;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FreeRec;
var i:Integer;
begin
  for i:=0 to TreeView1.Items.Count-1 do
    Dispose(TreeView1.Items[i].Data);
end;

function EnumFunc(wnd:HWND;lp:LPARAM):Boolean;stdcall;
var
  p1,p2:Array[0..100]of Char;
  Nt   :TTreeNode;
  pr   :PRec;
begin
  New(pr);
  GetWindowText(wnd,p1,100);
  GetClassName (wnd,p2,100);
  Nt :=TTreeNode(lp);
  pr^.Wnd:=Wnd;
  pr^.Txt:=StrPas(p1);
  pr^.Cls:=StrPas(p2);
  Nt :=Form1.TreeView1.Items.AddChildFirst(Nt,Format('%0.8x:%s[%s]',[pr^.Wnd,pr^.Txt,pr^.Cls]));
  Nt.Data:=pr;
  EnumChildWindows(wnd,@EnumFunc,Integer(Nt));
  Result:=true;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  FreeRec;
  TreeView1.Items.Clear;
  TreeView1.Items.BeginUpdate;
  EnumWindows(@EnumFunc,Integer(nil));
  TreeView1.Items.EndUpdate;
end;

procedure TForm1.TreeView1Click(Sender: TObject);
var
  Nt :TTreeNode;
  Dt :TRec;
  prd:DWORD;
begin
  Nt:=TreeView1.Selected;
  if(Nt=nil)then Exit;
  Dt:=PRec(Nt.Data)^;
  GetWindowThreadProcessId(Dt.Wnd,prd);
  Label1.Caption:=Format('Handle =%0.8x',[Dt.Wnd]);
  Label2.Caption:=Format('Process=%0.8x',[Prd]);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Label1.Caption:='';
  Label2.Caption:='';
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FreeRec;
end;

procedure TForm1.PopupMenu1Popup(Sender: TObject);
var
  Pt:PRec;
  d :Integer;
begin
  Pt:=nil;
  if TreeView1.Selected<>nil then Pt:=TreeView1.Selected.Data;
  if(Pt=nil)then begin
    E1.Enabled:=False;
    V1.Enabled:=False;
    N3.Enabled:=False;
  end else begin
    //
    E1.Enabled:=True;
    E1.Checked:=IsWindowEnabled(pt^.Wnd);
    //
    V1.Enabled:=True;
    V1.Checked:=IsWindowVisible(pt^.Wnd);
    //D
    N3.Enabled:=True;
    d:=GetWindowLong(pt^.Wnd,GWL_STYLE);
    N1.Checked:=((d and WS_CAPTION)>0);
  end;
end;

procedure TForm1.E1Click(Sender: TObject);
var
  Node:TTreeNode;
  Str :String;
  wd  :DWORD;
  fR  :TRect;
  procedure VisibleWindow(Const Wnd:HWnd;Const Bo:Boolean);
  begin
    if Bo then ShowWindow(Wnd,SW_SHOW)
          else ShowWindow(Wnd,SW_HIDE);
  end;
begin
  Node:=TreeView1.Selected;
  if(Node=nil)then Exit;
  with PRec(Node.Data)^ do begin
    wd:=GetWindowLong(Wnd,GWL_STYLE);
    Case TControl(Sender).Tag of
      1:EnableWindow(Wnd,Not E1.Checked);
      2:VisibleWindow(Wnd,Not V1.Checked);
      3:begin
          Str:=InputBox('D','JקD?',PRec(Node.Data)^.Txt);
          if(Str<>Txt)then begin
            Txt:=Str;
            Node.Text:=Format('%0.8x:%s[%s]',[Wnd,Txt,Cls]);
            SetWindowText(Wnd,PChar(Str));
          end;
        end;
      4:begin
          if((wd and WS_CAPTION)>0)then wd:=wd - WS_CAPTION
                                   else wd:=wd + WS_CAPTION;
          SetWindowLong(Wnd,GWL_STYLE,wd);
          if IsWindowVisible(Wnd)then begin
            VisibleWindow(Wnd,False);
            VisibleWindow(Wnd,True);
          end;
          //SetWindowPos(Wnd,HWND_NOTOPMOST,0,0,0,0,SWP_NOSIZE or SWP_NOMOVE);
        end;
    end;
  end;
end;

end.
